; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; ADC initialisieren mit "Free Run" und Vorteiler								
;																				
; 	ADEN: ADC Enable                             								
; 	ADSC: ADC Start Conversion                   								
; 	ADFR: ADC Free Running Select                								
; 	ADIF: ADC Interrzpt Flag                     								
; 	ADIE: ADC Interrupt Enable                   								
; 	ADPS2: Vorteiler                             								
; 	ADPS2: Vorteiler                             								
; 	ADPS2: Vorteiler                             								
;																				
;	ADPS2 ADPS1 ADPS0 Division Factor											
;	0 		0 	0 		2														
;	0 		0 	1 		2														
;	0 		1 	0 		4														
;	0 		1 	1 		8														
;	1 		0 	0 		16														
;	1 		0 	1	 	32														
; *	1 		1 	0 		64														
;	1 		1 	1 		128														
;																				
; ADC REFERENZ																	
; REFS1 REFS0 Voltage Reference Selection										
;  0     0    AREF, Internal Vref turned off									
;  0     1    AVCC with external capacitor at AREF pin							
; *1     1    Internal 2.56V Voltage Reference with external capacitor at AREF pin
;																				
ADC_INITIALISIERUNG:
	ldi temp, ((1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(0<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)) 
	out ADCSR, temp

	ldi temp, (1<<REFS1)|(1<<REFS0)
	out ADMUX, temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ADC-U																			
ADC_U:
	in temp, ADMUX
	andi temp, 0b11100000
	subi temp, 0			; KANAL 0				
	out ADMUX, temp
	rcall ADC_MESSEN		; OUT: TEMP1 / TEMP2	
;	ldi temp1,low (712)		; Testwert				
;	ldi temp2,high(712)
	STS(adr_ADC_U_L),temp1	; in SRAM speichern		
	STS(adr_ADC_U_H),temp2	; in SRAM speichern		
;-------------------------------------------------------------------------------
; mal Faktor																	
	ldi ZL,low (FAKTOR_U)	; Faktor			
	ldi ZH,high(FAKTOR_U)
	mov R1,temp1
	mov R2,temp2
	clr R3
	clr temp1				; Ergebnis clear	
	clr temp2
	clr temp3
;-------------------------------------------------------------------------------
ADC_U_s:
	add temp1,R1
	adc temp2,R2
	adc temp3,R3
	sbiw ZL,1				; Z-1				
	tst ZH
	brne ADC_U_s
	tst ZL
	brne ADC_U_s
; durch 256																		
	ldi ZL,low (128)		; aufrunden	halber Divisor addieren	
	ldi ZH,high(128)
	add temp1,ZL
	adc temp2,ZH
	mov temp1,temp2
	mov temp2,temp3
;-------------------------------------------------------------------------------
	ldi ZL,low (2)			; aufrunden	halber Divisor addieren	
	ldi ZH,high(2)
	add temp1,ZL
	adc temp2,ZH
	LSR temp2				; durch 2							
	ROR temp1
	LSR temp2				; durch 4							
	ROR temp1				
; Spannung-mom save																
	STS(adr_U_mom),temp1
;-------------------------------------------------------------------------------
; Mittelwert-save																
	LDS temp,(adr_ZEIGER_U)	; Zeiger load	
	ldi ZL,low (adr_DATA_U64) ; Z				
	ldi ZH,high(adr_DATA_U64)
	add ZL,temp				; addieren		
	adc ZH,NULL
	inc temp				; Zeiger +1		
	andi temp, 0b00111111
	STS(adr_ZEIGER_U),temp	; Zeiger save	
	ST Z+,temp1				; save			
; skip																			
	LDS temp,(adr_DATA_U64+63)
	tst temp
	brne BERECHNUNG_U_w
	LDS temp,(adr_U_mom)	; load			
	STS(adr_U),temp			; save			
	ret
; Mittewert																		
BERECHNUNG_U_w:
	ldi ZL,low (adr_DATA_U64) ; Z				
	ldi ZH,high(adr_DATA_U64)
	clr temp1
	clr temp2
	ldi temp9,64
BERECHNUNG_U_s:	
	LD temp,Z+
	add temp1,temp
	adc temp2,NULL
	dec temp9
	brne BERECHNUNG_U_s

	ldi temp3,low (23)		; aufrunden		
	ldi temp4,high(23)
	add temp1,temp3
	adc temp2,temp4
	LSR temp2				; :2			
	ROR temp1
	LSR temp2				; :4			
	ROR temp1
	LSR temp2				; :8			
	ROR temp1
	LSR temp2				; :16			
	ROR temp1
	LSR temp2				; :32			
	ROR temp1
	LSR temp2				; :64			
	ROR temp1

	STS(adr_U),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ADC-i																			
ADC_i:
	in temp, ADMUX
	andi temp, 0b11100000
	subi temp, -1			; KANAL 1				
	out ADMUX, temp
	rcall ADC_MESSEN		; OUT: TEMP1 / TEMP2	
;	ldi temp1,low (979)		; Testwert				
;	ldi temp2,high(979)
	STS(adr_ADC_i_L),temp1	; in SRAM speichern		
	STS(adr_ADC_i_H),temp2	; in SRAM speichern		
;-------------------------------------------------------------------------------
; Minus Offset																	
.equ OFFSET_i=985
	ldi temp3,low (OFFSET_i)
	ldi temp4,high(OFFSET_i)
	sub temp1,temp3
	sbc temp2,temp4
;-------------------------------------------------------------------------------
; wenn negativ, dann invertieren												
	tst temp2
	brpl ADC_i_pos
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
ADC_i_pos:
;-------------------------------------------------------------------------------
; mal Faktor																	
	ldi ZL,low (FAKTOR_i)	; Faktor			
	ldi ZH,high(FAKTOR_i)
	mov R1,temp1
	mov R2,temp2
	clr R3
	clr temp1				; Ergebnis clear	
	clr temp2
	clr temp3
;-------------------------------------------------------------------------------
ADC_i_s:
	add temp1,R1
	adc temp2,R2
	adc temp3,R3
	sbiw ZL,1				; Z-1				
	tst ZH
	brne ADC_i_s
	tst ZL
	brne ADC_i_s
; durch 256																		
	ldi ZL,low (128)		; aufrunden	halber Divisor addieren	
	ldi ZH,high(128)
	add temp1,ZL
	adc temp2,ZH
	mov temp1,temp2			; durch 256							
; 																				
; i-mom save																	
	STS(adr_i_mom),temp1
; Mittelwert-save																
	LDS temp,(adr_ZEIGER_i)	; Zeiger load	
	ldi ZL,low (adr_DATA_i64) ; Z				
	ldi ZH,high(adr_DATA_i64)
	add ZL,temp				; addieren		
	adc ZH,NULL
	inc temp				; Zeiger +1		
	andi temp, 0b00111111
	STS(adr_ZEIGER_i),temp	; Zeiger save	
	ST Z+,temp1				; save			
; skip																			
	LDS temp,(adr_DATA_i64+63)
	tst temp
	brne BERECHNUNG_i_w
	LDS temp,(adr_i_mom)	; load			
	STS(adr_i),temp			; save			
	ret
; Mittewert																		
BERECHNUNG_i_w:
	ldi ZL,low (adr_DATA_i64) ; Z				
	ldi ZH,high(adr_DATA_i64)
	clr temp1
	clr temp2
	ldi temp9,64
BERECHNUNG_i_s:	
	LD temp,Z+
	add temp1,temp
	adc temp2,NULL
	dec temp9
	brne BERECHNUNG_i_s

	ldi temp3,low (23)		; aufrunden		
	ldi temp4,high(23)
	add temp1,temp3
	adc temp2,temp4
	LSR temp2				; :2			
	ROR temp1
	LSR temp2				; :4			
	ROR temp1
	LSR temp2				; :8			
	ROR temp1
	LSR temp2				; :16			
	ROR temp1
	LSR temp2				; :32			
	ROR temp1
	LSR temp2				; :64			
	ROR temp1
; U-save																		
	STS(adr_i),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ADC-WERT 256 mal einlesen und daraus den Mittelwert bilden					
;																				
; OUT: 	TEMP1 (low)  															
;		TEMP2																	
; 																				
ADC_MESSEN:
	GRUEN_ON
	clr temp3	; HILFSREGISTER CLEAR								
	clr temp4
	clr temp5
	clr temp6
	clr temp9	; SCHLEIFE initialisieren		
;-------------------------------------------------------------------------------
; neuen ADC-Wert lesen	 Wert verwerfen, da meist vom vorherigem ADC-Kanal		
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !	
ADC_MESSEN_w:                  
	sbis ADCSRA, ADIF			; warten bis ADIF flag gesetzt		
	rjmp ADC_MESSEN_w
;-------------------------------------------------------------------------------
; neuen ADC-Wert lesen	(Schleife - 256 mal)									
ADC_MESSEN_s:                
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !	
ADC_MESSEN_w2:                
	sbis ADCSR, ADIF 			; warten bis ADIF flag gesetzt		
	rjmp ADC_MESSEN_w2
;-------------------------------------------------------------------------------
; ADC einlesen:																	
	in  temp1, ADCL 			; immer zuerst LOW Byte lesen
	in  temp2, ADCH 			; danach das mittlerweile gesperrte High Byte
;-------------------------------------------------------------------------------
; alle 256 ADC-Werte addieren													
	add temp4,temp1     		; addieren  						
	adc temp5,temp2     		; addieren ber Carry  				
	adc temp6,NULL    	 		; addieren ber Carry  				
	dec temp9			 		; Schleifenzhler MINUS 1			
	brne ADC_MESSEN_s 			; ==> SCHLEIFE						
;-------------------------------------------------------------------------------
; MITTELWERT-BERECHNUNG	(128 addieren)											
	ldi temp,128
	add temp4,temp	     		; addieren  						
	adc temp5,NULL	     		; addieren ber Carry  				
	adc temp6,NULL    	 		; addieren ber Carry  				
;-------------------------------------------------------------------------------
; 	Ergebnis durch 256 teilen (temp5+6 nach temp1+2 kopieren)					
	mov temp1,temp5
	mov temp2,temp6
	GRUEN_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
