; ##############################################################################
; ##############################################################################
; ##############################################################################
STARTWERTE:
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; Refreh			
	STS(adr_REFRESH),EINS
	; DATUM				
	ldi temp,5
	STS(adr_TAG),temp
	ldi temp,7
	STS(adr_MONAT),temp
	ldi temp,24
	STS(adr_JAHR),temp
	; Wochentag			
	ldi temp,5			; 1=Mo
	STS(adr_WOCHENTAG),temp
	; Zeit				
	ldi temp,0
	STS(adr_hh),temp
	ldi temp,0
	STS(adr_mm),temp
	ldi temp,0
	STS(adr_ss),temp
	; Wmm				
	ldi temp1,low (0)
	ldi temp2,high(0)
	STS(adr_Wmm_L),temp1
	STS(adr_Wmm_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
WDR_INITIALISIERUNG:
	ldi TEMP,(1<<WDCE)|(1<<WDE) ; Watchdog aktivieren (max. Zeit)				
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0
;-------------------------------------------------------------------------------
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PORT_INITIALISIERUNG:
	clr temp							; alles Eingang	
	out DDRB, temp
	out DDRC, temp
	out DDRD, temp
	out PORTB,temp				
	out PORTC,temp				
	out PORTD,temp	
; BEEP auf AUSGANG																	
	sbi (BEEP_DDR),(BEEP_PIN_NR)
	BEEP_OFF		
; LED auf AUSGANG																	
	sbi (GRUEN_DDR),(GRUEN_PIN_NR)		; 
	sbi (GELB_DDR), (GELB_PIN_NR)		; 
	sbi (ROT_DDR),  (ROT_PIN_NR)		; 
	sbi (BLAU_DDR), (BLAU_PIN_NR)		; 
; LEDs																			
	GRUEN_ON
	GELB_ON
	ROT_ON
	BLAU_ON
	rcall WAIT_100ms
	GRUEN_OFF
	GELB_OFF
	ROT_OFF
	BLAU_OFF
; TWI PULL-UP																	
	sbi (TWI_SDA_PORT),(TWI_SDA_PIN_NR)	; PullUp TWI-SDA	
	sbi (TWI_SCL_PORT),(TWI_SCL_PIN_NR)	; PullUp TWI-SDA	
	rcall WAIT_100ms
; SCL-Check (muss HIGH sein)													
	SBIS PINC,(TWI_SCL_PIN_NR)
	rjmp PORT_INITIALISIERUNG_ERROR_SCL
; SDA-Check (muss HIGH sein)													
	SBIS PINC,(TWI_SDA_PIN_NR)
	rjmp PORT_INITIALISIERUNG_ERROR_SDA
; Tasten auf Eingang															
	out DDRD, NULL
; Tasten Pull-UP																
	out PORTD,VOLL
	rcall WAIT_100ms
; Tasten-Check																	
	in temp, PIND
	com temp
	tst temp
	brne PORT_INITIALISIERUNG_ERROR_TASTEN
	ret
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
; SDA-ERROR																		
PORT_INITIALISIERUNG_ERROR_SDA:
	sbi (TWI_SCL_DDR) ,(TWI_SCL_PIN_NR)			; TWI-SCL OUT 	
	sbi (TWI_SCL_PORT),(TWI_SCL_PIN_NR)			; TWI-SCL HIGH	
	GRUEN_ON	
	GELB_OFF
	ROT_ON
	rcall BEEP_KURZ
	cbi (TWI_SCL_PORT),(TWI_SCL_PIN_NR)			; TWI-SCL LOW	
PORT_INITIALISIERUNG_ERROR_SDA_RESET:
	rjmp PORT_INITIALISIERUNG_ERROR_SDA_RESET
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
; SCL-ERROR																		
PORT_INITIALISIERUNG_ERROR_SCL:
	rjmp PORT_INITIALISIERUNG_ERROR_SCL
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
PORT_INITIALISIERUNG_ERROR_TASTEN:
	BEEP_ON
rjmp PORT_INITIALISIERUNG
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_STOP:
	WDR
	rjmp PROGRAMM_STOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_ERROR
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_ERROR
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_ERROR
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_ERROR
ret
;-------------------------------------------------------------------------------
PROGRAMM_CHECK_ERROR:
	rjmp PROGRAMM_CHECK_ERROR
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_WAIT:
	LDS temp,(adr_TASTE)
	tst temp
	brne TASTEN_WAIT_RUN
	rcall WAIT_100ms
	ret
;-------------------------------------------------------------------------------
TASTEN_WAIT_RUN:
;	rcall WAIT_100ms
	STS(adr_TASTE),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_KLICK:
	BEEP_ON
	rcall WAIT_1ms
	BEEP_OFF	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_KURZ:
	BEEP_ON
	rcall WAIT_50ms
	BEEP_OFF	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP:
	BEEP_ON
	rcall WAIT_1s
	BEEP_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; VERSION: 07/2015																
;																				
;	Division 16 bit-Zahl durch 8 bit Zahl										
;																				
;	input/Output 	temp1 (LOW)													
;	input/Output 	temp2 (HIGH)												
;																				
;	input			temp3	Divisor		 										
;																				
DIVISION_16_8:
	; Hilfsregister sichern		
	push temp6
	push temp7
	; Aufrunden halben Divisor dazuaddieren	
	mov temp,temp3
	LSR temp	
	add temp1,temp
	adc temp2,NULL
;-----------------------------------------------------------------------
	clr temp 			; Leere Hilfsregister
	ldi temp6,1			; Zhler Bit 1 auf 1 setzen)
	clr temp7
;-----------------------------------------------------------------------
div8a:
	clc 				; Carry-Bit leeren
	rol temp1 		
	rol temp2 		
	rol temp 			;  in das Hilfsregister rotieren		
	brcs div8b 			; Eine 1 ist herausgerollt, ziehe ab	
	cp temp,temp3 		; Divisionsergebnis 1 oder 0?			
	brcs div8c 			; berspringe Subtraktion, wenn kleiner	
div8b:
	sub temp,temp3	 	; Subtrahiere Divisor					
	sec 				; Setze carry-bit, Ergebnis ist eine 1	
	rjmp div8d 			
div8c:
	clc 				; Lsche carry-bit, Ergebnis ist eine 0
div8d:
	rol temp6 			; Rotiere carry-bit in das Ergebnis		
	rol temp7
	brcc div8a 			; solange Nullen aus dem Ergebnis rotieren: weitermachen
;-----------------------------------------------------------------------
	;Zurckschreiben	
	mov temp1, temp6
	mov temp2, temp7
;-----------------------------------------------------------------------
	; wieder herstellen	
	pop temp7
	pop temp6
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; VERSION: 11/2014																
;																				
; 	INPUT: 	TEMP1 (DIVIDENT)													
; 			TEMP2 (DIVISOR)														
;																				
DIVISION_8_8:
	push temp3
	push temp4
;-----------------------------------------------------------------------
	clr	temp3					; Ergebnis initialisieren		
	ldi	temp4,1					; Teilbarkeit durch 1 annehmen	
	tst	TEMP2
DIV_8_8_ww:
	brmi DIV_loop				; Den Divisor linksbndig ? -> JA=> SPRUNG	
	lsl	temp4					; Zwischenergebnis und						
	lsl	TEMP2					; Divisor einen Schritt nach links			
	rjmp DIV_8_8_ww
DIV_loop:
	cp	TEMP1,TEMP2				; divident >= divisor			
	brlo DIV_w					; -> nein=> SPRUNG				
	add	temp3,temp4				; Ergebnis vergrern und		
	sub	TEMP1,TEMP2				; Dividenten verkleinern		
DIV_w:	
	lsr	TEMP2					; Divisor und Zwischenergebnis	
	lsr	temp4					; einen Schritt nach rechts		
	brne	div_loop			; zw!=0 ? ->JA					
	mov temp1,temp3
;-----------------------------------------------------------------------
	pop temp4
	pop temp3
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
