;																								
;ADR 	BIT 7 	BIT 6 	BIT 5 	BIT 4 	BIT 3 	BIT 2 	BIT 1 	BIT 0 		FUNCTION 	RANGE 	
;00h 	CH(Clock Hold)			10 Seconds 						Seconds 	Seconds 	00-59 	
;01h 	0 						10 Minutes 						Minutes 	Minutes 	00-59 	
;02h 	0 		12 		10 Hour 10 Hour 						Hours 		Hours 		00-23 	
;03h 	0 		0 		0 		0 		0 						DAY 		Day 		01-07 	
;04h 	0 		0 		10 Date 								Date 		Date 		01-31 	
;05h 	0 		0 		0 		10 Month 						Month 		Month 		01-12 	
;06h 					10 Year 								Year 		Year 		00-99 	
;07h 	OUT 	0 		0 		SQWE 	0 		0 		RS1 	RS0 		Control 	- 		
;08h-3Fh 																	RAM 56 x 8 	00h-FFh 
;																								
TWI_RTC_READ:
; STATUSZEILE																	
	rcall ZEILE_0_CLEAR					; Zeile clear				
	rcall FARBE_GRAU
	rcall ASCII_SPACE20
	rcall TEXT_RTC
	rcall ASCII_r_
	rcall ASCII_e_
	rcall ASCII_a_
	rcall ASCII_d_
	rcall TFT_PAKET_SENDEN
;-------------------------------------------------------------------------------
	ldi temp1,(TWI_ADR_RTC)				; -- SLAVE ADRESSE + MT		
	rcall TWI_MT_START_TEMP1
	rcall TWI_STOP						; STOP						
	tst ERROR							; ERROR						
	brne TWI_RTC_READ_ERROR
;-------------------------------------------------------------------------------
	rcall RTC_READ
	brcs TWI_RTC_READ_OK
;-------------------------------------------------------------------------------
	rcall ASCII_s_
	rcall ASCII_e_
	rcall ASCII_t_
	rcall TWI_RTC_SET
	rcall WAIT_1s
;-------------------------------------------------------------------------------
	rcall RTC_READ
	brcc TWI_RTC_READ_ERROR
;-------------------------------------------------------------------------------
; Statuszeile																	
TWI_RTC_READ_OK:
	GELB_OFF
	ret
;-------------------------------------------------------------------------------
TWI_RTC_READ_ERROR:
	rcall ZEILE_0
	rcall FARBE_ROT
	rcall BEEP
	rcall TEXT_RTC
	rcall TEXT_ERROR
	rjmp TFT_PAKET_SENDEN
; ##############################################################################
; ##############################################################################
; ##############################################################################
; write Wmm im SRAM																
TWI_RTC_WRITE_Wmm:
; STATUSZEILE																	
	rcall ZEILE_0_CLEAR					; Zeile clear				
	rcall FARBE_GRAU
	rcall ASCII_SPACE20
	rcall TEXT_RTC
	rcall ASCII_w_
	rcall ASCII_SPACE
	rcall ASCII_W
	rcall ASCII_m_
	rcall ASCII_m_
	rcall TFT_PAKET_SENDEN
;-------------------------------------------------------------------------------
	ldi temp1,(TWI_ADR_RTC)				; SLAVE ADRESSE	
	rcall TWI_MT_START_TEMP1			; Start			
	ldi temp1,8							; ADRESS-ZEIGER	
	rcall TWI_MT_DATA_TEMP1				; Data			
; Hier wird der RAM genutzt, 												   	
;-- Byte-8 (RAM-Byte-0)Wmm_H ---------------------------------------------------
	LDS temp1,(adr_Wmm_H)
	rcall TWI_MT_DATA_TEMP1
;-- Byte-9 (RAM-Byte-1)Wmm_L ---------------------------------------------------
	LDS temp1,(adr_Wmm_L)
	rcall TWI_MT_DATA_TEMP1
;-- Byte-10(RAM-Byte-2)---------------------------------------------------------
	ldi temp1,1
	rcall TWI_MT_DATA_TEMP1
;-- Byte-11(RAM-Byte-3)---------------------------------------------------------
	ldi temp1,1
	rcall TWI_MT_DATA_TEMP1
;-- Byte-12(RAM-Byte-4)---------------------------------------------------------
	ldi temp1,1
	rcall TWI_MT_DATA_TEMP1
;-- Byte-13(RAM-Byte-5)---------------------------------------------------------
	ldi temp1,1
	rcall TWI_MT_DATA_TEMP1
;-- Byte-14(RAM-Byte-6)---------------------------------------------------------
	ldi temp1,1
	rcall TWI_MT_DATA_TEMP1
;-- Byte-15(RAM-Byte-7)---------------------------------------------------------
	ldi temp1,1
	rcall TWI_MT_DATA_TEMP1
	rjmp TWI_STOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
; DS1307 ZEIT / DATUM / RAM  setzen												
TWI_RTC_SET:
.equ RTC_CONTROL=0b00010000				; SEKUNDENTAKT am PIN aktivieren
; ------------------------------------------------------------------------------
	GRUEN_OFF
	ldi temp1,(TWI_ADR_RTC)				; SLAVE ADRESSE	
	rcall TWI_MT_START_TEMP1			; Start			
	ldi temp1,0							; ADRESS-ZEIGER	
	rcall TWI_MT_DATA_TEMP1				; Data			
;-- BYTE-0 (SEKUNDEN) ----------------------------------------------------------
	LDS temp1,(adr_ss)
	andi temp,0b01111111				; bereinigen (ev. gesetztes Bit7)	
	rcall DS1307_DEZ_HEX_TEMP1			; Umrechnen		
	rcall TWI_MT_DATA_TEMP1
;-- BYTE-1 (MINUTEN) -----------------------------------------------------------
	LDS temp1,(adr_mm)
	rcall DS1307_DEZ_HEX_TEMP1			; Umrechnen		
	rcall TWI_MT_DATA_TEMP1
;-- BYTE-2 (STUNDEN) -----------------------------------------------------------
	LDS temp1,(adr_hh)
	rcall DS1307_DEZ_HEX_TEMP1			; Umrechnen		
	rcall TWI_MT_DATA_TEMP1
;-- BYTE-3 (WOCHENTAG) ---------------------------------------------------------
	LDS temp1,(adr_WOCHENTAG)
	rcall DS1307_DEZ_HEX_TEMP1			; Umrechnen		
	rcall TWI_MT_DATA_TEMP1
;-- BYTE-4 (TAG) ---------------------------------------------------------------
	LDS temp1,(adr_TAG)
	rcall DS1307_DEZ_HEX_TEMP1			; Umrechnen		
	rcall TWI_MT_DATA_TEMP1
;-- BYTE-5 (MONAT) -------------------------------------------------------------
	LDS temp1,(adr_MONAT)
	rcall DS1307_DEZ_HEX_TEMP1			; Umrechnen		
	rcall TWI_MT_DATA_TEMP1
;-- BYTE-6 (JAHR) --------------------------------------------------------------
	LDS temp1,(adr_JAHR)
	rcall DS1307_DEZ_HEX_TEMP1			; Umrechnen		
	rcall TWI_MT_DATA_TEMP1
;-- Byte-7 (Control)-----------------------------------------------------------
	ldi temp1,(RTC_CONTROL)				; SEKUNDENTAKT am PIN aktivieren
	rcall TWI_MT_DATA_TEMP1
;-------------------------------------------------------------------------------
	rcall TWI_STOP						; STOP			
	tst ERROR
	breq DS1307_UHR_STELLEN_OK 
;-------------------------------------------------------------------------------
DS1307_UHR_STELLEN_ERROR:
	ROT_ON	; ROT
	ret
;-------------------------------------------------------------------------------
DS1307_UHR_STELLEN_OK:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; alles clear																	
TWI_RTC_RESET:
	ldi temp1,(TWI_ADR_RTC)				; SLAVE ADRESSE	
	rcall TWI_MT_START_TEMP1			; Start			
	ldi temp1,0							; ADRESS-ZEIGER	
	rcall TWI_MT_DATA_TEMP1				; Data			
	ldi temp9,10
;-------------------------------------------------------------------------------1
TWI_RTC_RESET_s:
	clr temp1
	rcall TWI_MT_DATA_TEMP1
	dec temp9
	brne TWI_RTC_RESET_s
	rjmp TWI_STOP						; STOP			
; ##############################################################################
; ##############################################################################
; ##############################################################################
RTC_READ:
	ldi temp1,(TWI_ADR_RTC)			; -- SLAVE ADRESSE + MT				
	rcall TWI_MT_START_TEMP1
	ldi temp1,0						; -- ADRESS-ZEIGER setzen			
	rcall TWI_MT_DATA_TEMP1
	ldi temp1,(TWI_ADR_RTC)			; -- SLAVE ADRESSE + MR				
	rcall TWI_MR_START_TEMP1
	ldi temp9,21					; Schleife							
	ldi ZL,LOW (adr_TWI_BEREICH)
	ldi ZH,HIGH(adr_TWI_BEREICH)
;-------------------------------------------------------------------------------
DS1307_UHR_AUSLESEN_s:
	rcall TWI_MR_DATA_TEMP1	
	ST Z+,temp1
	dec temp9						; Schleife							
	brne DS1307_UHR_AUSLESEN_s
;-------------------------------------------------------------------------------
	rcall TWI_MR_LAST_DATA_TEMP1	; DUMMY								
	rcall TWI_STOP					; STOP								
	tst ERROR						; ERROR								
	brne DS1307_ERROR
;-------------------------------------------------------------------------------
; AUSWERTUNG																	
	LDS temp,(adr_TWI_BEREICH+0)	; BYTE-0(Sekunden)					
	andi temp,0b01111111			; bereinigen (ev. gesetztes Bit7)	
	rcall DS1307_HEX_NACH_DEZ_TEMP	; Umrechnung						
	STS(adr_ss),temp				; save								
;-------------------------------------------------------------------------------
	LDS temp,(adr_TWI_BEREICH+1)	; BYTE-1(Minuten)					
	rcall DS1307_HEX_NACH_DEZ_TEMP	; Umrechnung						
	STS(adr_mm),temp
;-------------------------------------------------------------------------------
	LDS temp,(adr_TWI_BEREICH+2)	; BYTE-2(STUNDEN)					
	rcall DS1307_HEX_NACH_DEZ_TEMP	; Umrechnung						
	STS(adr_hh),temp
;-------------------------------------------------------------------------------
	LDS temp,(adr_TWI_BEREICH+3)	; BYTE-3(WOCHENTAG 01..07)			
	STS(adr_WOCHENTAG),temp 
;-------------------------------------------------------------------------------
	LDS temp,(adr_TWI_BEREICH+4)	; BYTE-4(TAG 01...31) 				
	rcall DS1307_HEX_NACH_DEZ_TEMP	; Umrechnung						
	STS(adr_TAG),temp
;-------------------------------------------------------------------------------
	LDS temp,(adr_TWI_BEREICH+5)	; BYTE-5(MONAT 01..12)				
	rcall DS1307_HEX_NACH_DEZ_TEMP	; Umrechnung						
	STS(adr_MONAT),temp
;-------------------------------------------------------------------------------
	LDS temp,(adr_TWI_BEREICH+6)	; BYTE-6(JAHR 00...99)				
	rcall DS1307_HEX_NACH_DEZ_TEMP	; Umrechnung						
	STS(adr_JAHR),temp
;-------------------------------------------------------------------------------
	LDS temp,(adr_TWI_BEREICH+7)	; BYTE-7(Control)					
	cpi temp,(RTC_CONTROL)
	brne DS1307_ERROR
;-------------------------------------------------------------------------------
	LDS temp,(adr_TWI_BEREICH+0)	; BYTE-0(Sekunden)					
	andi temp,0b10000000			; ev. gesetztes Bit7 ?				
	tst temp
	brne DS1307_ERROR
;-------------------------------------------------------------------------------
	LDS temp1,(adr_TWI_BEREICH+8)	; BYTE-8 Wmm_H						
	STS(adr_Wmm_H),temp1			; save								
;-------------------------------------------------------------------------------
	LDS temp1,(adr_TWI_BEREICH+9)	; BYTE-9 Wmm_L						
	STS(adr_Wmm_L),temp1			; save								
;-------------------------------------------------------------------------------
DS1307_OK:
	SEC 							; Set Carry							
ret
;-------------------------------------------------------------------------------
DS1307_ERROR:
	ldi temp,0x10
	STS(adr_ERROR),temp
	ROT_ON							; ROT								
	CLC 							; Clear Carry						
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DS1307_HEX_NACH_DEZ_TEMP:
	mov temp1,temp			; kopieren in Hilfsregister			
	andi temp1,0b00001111	; Hilfsregister selektieren			
	LSR temp				; 4 x rechts						
	LSR temp
	LSR temp
	LSR temp
	add temp1,temp			; 10 x addieren						
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	add temp1,temp
	mov temp,temp1			; kopieren 							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP/OUT: temp1																
DS1307_DEZ_HEX_TEMP1:
	cpi temp1,100
	brsh DS1307_UHR_STELLEN_BCD_ERROR
	cpi temp1,90
	brsh DS1307_UHR_STELLEN_90
	cpi temp1,80
	brsh DS1307_UHR_STELLEN_80
	cpi temp1,70
	brsh DS1307_UHR_STELLEN_70
	cpi temp1,60
	brsh DS1307_UHR_STELLEN_60
	cpi temp1,50
	brsh DS1307_UHR_STELLEN_50
	cpi temp1,40
	brsh DS1307_UHR_STELLEN_40
	cpi temp1,30
	brsh DS1307_UHR_STELLEN_30
	cpi temp1,20
	brsh DS1307_UHR_STELLEN_20
	cpi temp1,10
	brsh DS1307_UHR_STELLEN_10
	rjmp DS1307_UHR_STELLEN_00
DS1307_UHR_STELLEN_00:
	ret
DS1307_UHR_STELLEN_10:
	subi temp1,10 			; -10				
	ori temp1, 0b00010000	; 10er Bit setzen	
	ret
DS1307_UHR_STELLEN_20:
	subi temp1,20 			; -20				
	ori temp1, 0b00100000	; 20er Bit setzen	
	ret
DS1307_UHR_STELLEN_30:
	subi temp1,30 			; -30				
	ori temp1, 0b00110000	; 30er Bit setzen	
	ret
DS1307_UHR_STELLEN_40:
	subi temp1,40 			; -40				
	ori temp1, 0b01000000	; 40er Bit setzen	
	ret
DS1307_UHR_STELLEN_50:
	subi temp1,50 			; -50				
	ori temp1, 0b01010000	; 50er Bit setzen	
	ret
DS1307_UHR_STELLEN_60:
	subi temp1,60 			; -60				
	ori temp1, 0b01100000	; 60er Bit setzen	
	ret
DS1307_UHR_STELLEN_70:
	subi temp1,70 			; -70				
	ori temp1, 0b01110000	; 70er Bit setzen	
	ret
DS1307_UHR_STELLEN_80:
	subi temp1,80 			; -80				
	ori temp1, 0b10000000	; 80er Bit setzen	
	ret
DS1307_UHR_STELLEN_90:
	subi temp1,90 			; -90				
	ori temp1, 0b10010000	; 90er Bit setzen	
	ret
DS1307_UHR_STELLEN_BCD_ERROR:
	clr temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################







